'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _extends = require('babel-runtime/helpers/extends')['default'];

var _Object$keys = require('babel-runtime/core-js/object/keys')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _reactRelayLibGraphQLFragmentPointer = require('react-relay/lib/GraphQLFragmentPointer');

var _reactRelayLibGraphQLFragmentPointer2 = _interopRequireDefault(_reactRelayLibGraphQLFragmentPointer);

var _reactRelay = require('react-relay');

var _reactRelay2 = _interopRequireDefault(_reactRelay);

var _reactRelayLibRelayQuery = require('react-relay/lib/RelayQuery');

var _reactRelayLibRelayQuery2 = _interopRequireDefault(_reactRelayLibRelayQuery);

var _reactRelayLibRelayRenderer = require('react-relay/lib/RelayRenderer');

var _reactRelayLibRelayRenderer2 = _interopRequireDefault(_reactRelayLibRelayRenderer);

var _reactRelayLibRelayStoreData = require('react-relay/lib/RelayStoreData');

var _reactRelayLibRelayStoreData2 = _interopRequireDefault(_reactRelayLibRelayStoreData);

var IsomorphicRenderer = (function (_RelayRenderer) {
    _inherits(IsomorphicRenderer, _RelayRenderer);

    function IsomorphicRenderer() {
        _classCallCheck(this, IsomorphicRenderer);

        _get(Object.getPrototypeOf(IsomorphicRenderer.prototype), 'constructor', this).apply(this, arguments);
    }

    _createClass(IsomorphicRenderer, [{
        key: '_runQueries',
        value: function _runQueries(props) {
            // _runQueries should not be called on server side,
            // so don't call it from constructor, and call it from componentDidMount instead
            return this.state ? _get(Object.getPrototypeOf(IsomorphicRenderer.prototype), '_runQueries', this).call(this, props) : this._createInitialIsomorphicState(props);
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            if ((!this.state.readyState || this.props.forceFetch) && !this.state.pendingRequest) {
                this.setState(_get(Object.getPrototypeOf(IsomorphicRenderer.prototype), '_runQueries', this).call(this, this.props));
            }
        }
    }, {
        key: '_createInitialIsomorphicState',
        value: function _createInitialIsomorphicState(_ref) {
            var Component = _ref.Component;
            var forceFetch = _ref.forceFetch;
            var queryConfig = _ref.queryConfig;

            var querySet = _reactRelay2['default'].getQueries(Component, queryConfig);
            var fragmentPointers = createFragmentPointersForRoots(querySet);

            return isDataReady(querySet, fragmentPointers) ? {
                activeComponent: Component,
                activeQueryConfig: queryConfig,
                pendingRequest: null,
                readyState: {
                    aborted: false,
                    done: true,
                    error: null,
                    mounted: true,
                    ready: true,
                    stale: forceFetch
                },
                renderArgs: {
                    done: true,
                    error: null,
                    props: _extends({}, queryConfig.params, fragmentPointers),
                    retry: this._retry.bind(this),
                    stale: forceFetch
                }
            } : {
                activeComponent: null,
                activeQueryConfig: null,
                pendingRequest: null,
                readyState: null,
                renderArgs: {
                    done: false,
                    error: null,
                    props: null,
                    retry: this._retry.bind(this),
                    stale: false
                }
            };
        }
    }]);

    return IsomorphicRenderer;
})(_reactRelayLibRelayRenderer2['default']);

exports['default'] = IsomorphicRenderer;

var queuedStore = _reactRelayLibRelayStoreData2['default'].getDefaultInstance().getQueuedStore();

function createFragmentPointersForRoots(querySet) {
    var fragmentPointers = {};

    _Object$keys(querySet).forEach(function (name) {
        fragmentPointers[name] = createFragmentPointerForRoot(querySet[name]);
    });
    return fragmentPointers;
}

var createFragmentPointerForRoot = function createFragmentPointerForRoot(query) {
    return query ? _reactRelayLibGraphQLFragmentPointer2['default'].createForRoot(queuedStore, query) : null;
};

var isDataReady = function isDataReady(querySet, fragmentPointers) {
    return _Object$keys(querySet).every(function (name) {
        return fragmentPointers[name] || !queryHasRootFragment(querySet[name]);
    });
};

var queryHasRootFragment = function queryHasRootFragment(query) {
    return query && query.getChildren().some(function (child) {
        return child instanceof _reactRelayLibRelayQuery2['default'].Fragment;
    });
};
module.exports = exports['default'];