'use strict';

var _Promise = require('babel-runtime/core-js/promise')['default'];

var _Object$keys = require('babel-runtime/core-js/object/keys')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _reactRelayLibDliteFetchModeConstants = require('react-relay/lib/DliteFetchModeConstants');

var _reactRelayLibDliteFetchModeConstants2 = _interopRequireDefault(_reactRelayLibDliteFetchModeConstants);

var _reactRelay = require('react-relay');

var _reactRelay2 = _interopRequireDefault(_reactRelay);

var _reactRelayLibRelayPendingQueryTracker = require('react-relay/lib/RelayPendingQueryTracker');

var _reactRelayLibRelayPendingQueryTracker2 = _interopRequireDefault(_reactRelayLibRelayPendingQueryTracker);

var _reactRelayLibRelayStoreData = require('react-relay/lib/RelayStoreData');

var _reactRelayLibRelayStoreData2 = _interopRequireDefault(_reactRelayLibRelayStoreData);

var queryRunner = _reactRelayLibRelayStoreData2['default'].getDefaultInstance().getQueryRunner();

exports['default'] = function (_ref, queryResults) {
    var Component = _ref.Component;
    var route = _ref.route;

    var querySet = _reactRelay2['default'].getQueries(Component, route);

    var request = new _Promise(function (resolve, reject) {
        queryRunner.run(querySet, function (_ref2) {
            var aborted = _ref2.aborted;
            var done = _ref2.done;
            var error = _ref2.error;

            if (error) {
                reject(error);
            } else if (aborted) {
                reject(new Error('Aborted'));
            } else if (done) {
                resolve();
            }
        }, _reactRelayLibDliteFetchModeConstants2['default'].FETCH_MODE_PRELOAD);
    });
    _Object$keys(querySet).forEach(function (name) {
        var result = queryResults[name];
        if (!result) {
            throw new Error('No result for query "' + name + '"');
        }
        _reactRelayLibRelayPendingQueryTracker2['default'].resolvePreloadQuery(querySet[name].getID(), { response: result });
    });
    return request;
};

module.exports = exports['default'];